/*
 * tkresolver - Telekinesis testing software
 *
 * Copyright (C) 2004 Robert Ham <rah@bash.sh>
 *
 * GPL all the way, baby :)
 *
 */

#ifndef __TK_EXP_INTENT_SELECTOR_H__
#define __TK_EXP_INTENT_SELECTOR_H__

#include <gtkmm.h>

#include "libtkdb/database.h"

namespace TkResolver {
  namespace Experimenter {
    
    class IntentSelector : public Gtk::TreeView
      {
      private:
	class Columns : public Gtk::TreeModel::ColumnRecord
	  {
	  public:
	    Gtk::TreeModelColumn<Glib::ustring> code;
	    Gtk::TreeModelColumn<Glib::ustring> description;
	    Columns() { add(code); add(description); }
	  };
	
	Columns                      _columns;
	Glib::RefPtr<Gtk::ListStore> _store; 
	
	void fill_list(Db::Database * database, unsigned trace_count);

      public:
	IntentSelector(Db::Database * database, unsigned trace_count);
	Db::Code get_intent_code();
      };
    
  } /* namespace Experimenter */
}; /* namespace TkResolver */

#endif /* __TK_EXP_INTENT_SELECTOR_H__ */
