/*
 * tkresolver - Telekinesis testing software
 *
 * Copyright (C) 2004 Robert Ham <rah@bash.sh>
 *
 * GPL all the way, baby :)
 *
 */

#ifndef __TK_EXP_SCREEN_SIZE_H__
#define __TK_EXP_SCREEN_SIZE_H__

#include <gtkmm.h>

namespace TkResolver {
  namespace Experimenter {

    class ResolutionListColumns : public Gtk::TreeModel::ColumnRecord
      {
      public:
	Gtk::TreeModelColumn<unsigned> width;
	Gtk::TreeModelColumn<unsigned> height;

	ResolutionListColumns();
      };

    class ScreenSize : public Gtk::ComboBox
      {
      private:
	ResolutionListColumns _columns;
	Glib::RefPtr<Gtk::ListStore> _store;
	Gtk::CellRendererText _cell;
	
	void load_std_modes();
	void load_modes();
	bool check_and_set_active_mode(const Gtk::TreeModel::iterator& iter,
				       unsigned width,
				       unsigned height,
				       bool * set);
	bool set_active_mode(unsigned width, unsigned height);
	void set_default_mode();

	void set_cell_text (const Gtk::TreeModel::const_iterator & iter, Glib::RefPtr<Gtk::CellRendererText> cell);
      public:
	ScreenSize();
	unsigned get_width() const;
	unsigned get_height() const;
      };

  } /* namespace Experimenter */
}; /* namespace TkResolver */

#endif /* __TK_EXP_SCREEN_SIZE_H__ */
