/* -*- c++ -*-
 * tkresolver - Telekinesis testing software
 *
 * Copyright (C) 2004-2007 Robert Ham <rah@bash.sh>
 *
 * GPL all the way, baby :)
 *
 */

#ifndef __TK_DB_UI_DATA_SELECTOR_INPUT_LIST_H__
#define __TK_DB_UI_DATA_SELECTOR_INPUT_LIST_H__

#include <gtkmm.h>

#include "data_selector_list.h"

namespace TkResolver {
  namespace Db {
    namespace Ui {

      class DataInput : public Gtk::Dialog
	{
	protected:
	  DataInput(const Glib::ustring & title, Gtk::Window & parent);
	  virtual void get_values_sub(Db::PStatement &stmt) = 0;
	public:
	  virtual StringList get_insert_columns() = 0;
	  bool get_values(Db::PStatement &stmt);
	};
      
      template<typename DI> class DataSelectorInputList : public DataSelectorList
	{
	private:
	  Gtk::Window *_parent;
	  void input();
	protected:
	  
	  DataSelectorInputList(Db::Database *database,
				const String &table,
				const StringList &selection_columns,
				Gtk::Window *parent,
				const String &title);
	  
	  virtual void refreshed();
	};

      #include "data_selector_input_list_impl.h"
      
    } /* namespace Ui */
  } /* namespace Db */
}; /* namespace TkResolver */




#endif /* __TK_DB_UI_DATA_SELECTOR_INPUT_LIST_H__ */
