/*
 * tkresolver - Telekinesis testing software
 *
 * Copyright (C) 2004 Robert Ham <rah@bash.sh>
 *
 * GPL all the way, baby :)
 *
 */

#ifndef __TK_DECISION_TREE_H__
#define __TK_DECISION_TREE_H__

#include <wchar.h>

#include <iostream>

#include "randomness.h"
#include "random_types.h"

namespace TkResolver {

  namespace Random {

    class DecisionTree
    {
    private:
      class Node
      {
      private:
	Node *     _children[2];
	unsigned * _outcome;
      public:
	Node (unsigned outcomes, unsigned depth, unsigned &outcome);
	~Node ();

	unsigned get_outcome (Node * root, unsigned bit_descriptor, Randomness &rand, unsigned &retries) const;
      };

      unsigned _outcomes;
      unsigned _bit_multiplier;
      unsigned _depth;
      Node *   _root;
      unsigned _retries;

    public:
      DecisionTree (unsigned noutcomes, unsigned bit_multiplier);
      ~DecisionTree ();
      
      unsigned generate_event(Randomness &rand);
      
      unsigned get_depth() const;
      unsigned get_retries() const;
      unsigned tree_outcomes() const;
      double expected_tries() const;
      bool deterministic() const;
    };
    
  };
  
};


#endif /* __TK_DECISION_TREE_H__ */
