/* -*- c++ -*-
 * tkresolver - Telekinesis testing software
 *
 * Copyright (C) 2004-2007 Robert Ham <rah@bash.sh>
 *
 * GPL all the way, baby :)
 *
 */

#ifndef __TK_RANDOM_TYPES_H__
#define __TK_RANDOM_TYPES_H__

#include <vector>
#include <limits>
#include <string>
#include <sstream>
#include <wchar.h>

namespace TkResolver {
  
  namespace Random {

#ifdef ODBCXX_UNICODE
    typedef wchar_t BitChar;
#else    
    typedef char BitChar;
#endif /* ODBCXX_UNICODE */

    typedef std::basic_istringstream<BitChar> BitIStream;
    typedef std::vector<BitChar> Buffer;

    static const unsigned short BITS_PER_CHAR =
      std::numeric_limits<BitChar>::digits + static_cast<unsigned>(std::numeric_limits<BitChar>::is_signed);
    
    
    class Bits : public std::vector<bool>
      {
      public:
	BitIStream * get_data() const;
	size_type get_data_len() const;
      };
    
  }; /* namespace Random */
  
}; /* namespace TkResolver */


#endif /* __TK_RANDOM_TYPES_H__ */
