/*
 * tkresolver - Telekinesis testing software
 *
 * Copyright (C) 2004 Robert Ham <rah@bash.sh>
 *
 * GPL all the way, baby :)
 *
 */

#ifndef __TK_RETRIEVER_REGISTRY_H__
#define __TK_RETRIEVER_REGISTRY_H__

#include <wchar.h>

#include <string>

#include "libtkcommon/tkstring.h"
#include "retriever.h"

namespace TkResolver {

  namespace Random {

    class RetrieverType
    {
    public:
      virtual bool is_true_randomness() = 0;
      virtual unsigned get_preferred_block_size () = 0;
      virtual Retriever * new_retriever(unsigned count) = 0;
    };

    typedef std::pair<RetrieverType *, String> RetrieverDetails;
    typedef std::map<String, RetrieverDetails> RetrieverTypeMap;

    class RetrieverRegistry
    {
    private:
      static const RetrieverTypeMap _registry;
      
      static const RetrieverDetails & get_retriever_details(const String &type);
      static RetrieverType * get_retriever (const String &type);
    public:
      static StringList get_names();
      static bool is_true_randomness(const String &type);
      static unsigned get_preferred_block_size(const String &type);
      static Retriever * new_retriever(const String &name, unsigned count);
      static const String & get_retriever_description(const String &name);
    };

  };
  
};


#endif /* __TK_RETRIEVER_REGISTRY_H__ */
